Index: trunk/lib/FlairFilter/src/Gx3_25_ahrs.cpp
===================================================================
--- trunk/lib/FlairFilter/src/Gx3_25_ahrs.cpp	(revision 262)
+++ trunk/lib/FlairFilter/src/Gx3_25_ahrs.cpp	(revision 268)
@@ -15,4 +15,5 @@
 //
 /*********************************************************************/
+#ifdef ARMV7A
 
 #include "Gx3_25_ahrs.h"
@@ -54,2 +55,4 @@
 } // end namespace filter
 } // end namespace flair
+
+#endif
Index: trunk/lib/FlairFilter/src/SimuAhrs.cpp
===================================================================
--- trunk/lib/FlairFilter/src/SimuAhrs.cpp	(revision 262)
+++ trunk/lib/FlairFilter/src/SimuAhrs.cpp	(revision 268)
@@ -15,4 +15,5 @@
 //
 /*********************************************************************/
+#ifdef CORE2_64
 
 #include "SimuAhrs.h"
@@ -52,2 +53,4 @@
 } // end namespace filter
 } // end namespace flair
+
+#endif
Index: trunk/lib/FlairMeta/src/HdsX8.cpp
===================================================================
--- trunk/lib/FlairMeta/src/HdsX8.cpp	(revision 262)
+++ trunk/lib/FlairMeta/src/HdsX8.cpp	(revision 268)
@@ -15,4 +15,5 @@
 //
 /*********************************************************************/
+#ifdef ARMV7A
 
 #include "HdsX8.h"
@@ -76,2 +77,4 @@
 } // end namespace meta
 } // end namespace flair
+
+#endif
Index: trunk/lib/FlairMeta/src/SimuX4.cpp
===================================================================
--- trunk/lib/FlairMeta/src/SimuX4.cpp	(revision 262)
+++ trunk/lib/FlairMeta/src/SimuX4.cpp	(revision 268)
@@ -15,4 +15,5 @@
 //
 /*********************************************************************/
+#ifdef CORE2_64
 
 #include "SimuX4.h"
@@ -102,2 +103,4 @@
 } // end namespace meta
 } // end namespace flair
+
+#endif
Index: trunk/lib/FlairMeta/src/SimuX8.cpp
===================================================================
--- trunk/lib/FlairMeta/src/SimuX8.cpp	(revision 262)
+++ trunk/lib/FlairMeta/src/SimuX8.cpp	(revision 268)
@@ -15,4 +15,5 @@
 //
 /*********************************************************************/
+#ifdef CORE2_64
 
 #include "SimuX8.h"
@@ -102,2 +103,4 @@
 } // end namespace meta
 } // end namespace flair
+
+#endif
Index: trunk/lib/FlairMeta/src/UavFactory.cpp
===================================================================
--- trunk/lib/FlairMeta/src/UavFactory.cpp	(revision 262)
+++ trunk/lib/FlairMeta/src/UavFactory.cpp	(revision 268)
@@ -57,4 +57,5 @@
   }
 
+#ifdef ARMV7A
   if (type == "hds_x4") {
     getFrameworkManager()->Err("UAV type %s not yet implemented\n", type.c_str());
@@ -67,5 +68,11 @@
     getFrameworkManager()->Err("UAV type %s not yet implemented\n", type.c_str());
     return NULL;
-  } else if (type.compare(0, 7, "x4_simu") == 0) {
+  } else {
+    getFrameworkManager()->Err("UAV type %s unknown\n", type.c_str());
+    return NULL;
+  }
+#endif
+#ifdef CORE2_64
+  if (type.compare(0, 7, "x4_simu") == 0) {
     int simu_id = 0;
     if (type.size() > 7) {
@@ -83,4 +90,5 @@
     return NULL;
   }
+#endif
 }
 
Index: trunk/lib/FlairMeta/src/XAir.cpp
===================================================================
--- trunk/lib/FlairMeta/src/XAir.cpp	(revision 262)
+++ trunk/lib/FlairMeta/src/XAir.cpp	(revision 268)
@@ -15,4 +15,5 @@
 //
 /*********************************************************************/
+#ifdef ARMV7A
 
 #include "XAir.h"
@@ -72,2 +73,4 @@
 } // end namespace meta
 } // end namespace flair
+
+#endif
Index: trunk/lib/FlairSensorActuator/src/AfroBldc.cpp
===================================================================
--- trunk/lib/FlairSensorActuator/src/AfroBldc.cpp	(revision 262)
+++ trunk/lib/FlairSensorActuator/src/AfroBldc.cpp	(revision 268)
@@ -15,4 +15,5 @@
 //
 /*********************************************************************/
+#ifdef ARMV7A
 
 #include "AfroBldc.h"
@@ -47,2 +48,4 @@
 } // end namespace actuator
 } // end namespace flair
+
+#endif
Index: trunk/lib/FlairSensorActuator/src/AfroBldc_impl.cpp
===================================================================
--- trunk/lib/FlairSensorActuator/src/AfroBldc_impl.cpp	(revision 262)
+++ trunk/lib/FlairSensorActuator/src/AfroBldc_impl.cpp	(revision 268)
@@ -15,4 +15,6 @@
 //
 /*********************************************************************/
+#ifdef ARMV7A
+
 #include "AfroBldc_impl.h"
 #include "AfroBldc.h"
@@ -71,2 +73,4 @@
   }
 }
+
+#endif
Index: trunk/lib/FlairSensorActuator/src/BlCtrlV2.cpp
===================================================================
--- trunk/lib/FlairSensorActuator/src/BlCtrlV2.cpp	(revision 262)
+++ trunk/lib/FlairSensorActuator/src/BlCtrlV2.cpp	(revision 268)
@@ -15,4 +15,5 @@
 //
 /*********************************************************************/
+#ifdef ARMV7A
 
 #include "BlCtrlV2.h"
@@ -52,2 +53,4 @@
 } // end namespace actuator
 } // end namespace flair
+
+#endif
Index: trunk/lib/FlairSensorActuator/src/BlCtrlV2_impl.cpp
===================================================================
--- trunk/lib/FlairSensorActuator/src/BlCtrlV2_impl.cpp	(revision 262)
+++ trunk/lib/FlairSensorActuator/src/BlCtrlV2_impl.cpp	(revision 268)
@@ -15,4 +15,6 @@
 //
 /*********************************************************************/
+#ifdef ARMV7A
+
 #include "BlCtrlV2_impl.h"
 #include "BlCtrlV2.h"
@@ -209,2 +211,4 @@
   nb_mot = nb;
 }
+
+#endif
Index: trunk/lib/FlairSensorActuator/src/BlCtrlV2_x4_speed.cpp
===================================================================
--- trunk/lib/FlairSensorActuator/src/BlCtrlV2_x4_speed.cpp	(revision 262)
+++ trunk/lib/FlairSensorActuator/src/BlCtrlV2_x4_speed.cpp	(revision 268)
@@ -15,4 +15,5 @@
 //
 /*********************************************************************/
+#ifdef ARMV7A
 
 #include "BlCtrlV2_x4_speed.h"
@@ -493,2 +494,4 @@
 } // end namespace actuator
 } // end namespace flair
+
+#endif
Index: trunk/lib/FlairSensorActuator/src/Gx3_25_imu.cpp
===================================================================
--- trunk/lib/FlairSensorActuator/src/Gx3_25_imu.cpp	(revision 262)
+++ trunk/lib/FlairSensorActuator/src/Gx3_25_imu.cpp	(revision 268)
@@ -15,4 +15,5 @@
 //
 /*********************************************************************/
+#ifdef ARMV7A
 
 #include "Gx3_25_imu.h"
@@ -56,2 +57,4 @@
 } // end namespace sensor
 } // end namespace flair
+
+#endif
Index: trunk/lib/FlairSensorActuator/src/Gx3_25_imu_impl.cpp
===================================================================
--- trunk/lib/FlairSensorActuator/src/Gx3_25_imu_impl.cpp	(revision 262)
+++ trunk/lib/FlairSensorActuator/src/Gx3_25_imu_impl.cpp	(revision 268)
@@ -15,4 +15,5 @@
 //
 /*********************************************************************/
+#ifdef ARMV7A
 
 #include "Gx3_25_imu_impl.h"
@@ -627,2 +628,4 @@
     return true;
 }
+
+#endif
Index: trunk/lib/FlairSensorActuator/src/Mb800.cpp
===================================================================
--- trunk/lib/FlairSensorActuator/src/Mb800.cpp	(revision 262)
+++ trunk/lib/FlairSensorActuator/src/Mb800.cpp	(revision 268)
@@ -15,4 +15,5 @@
 //
 /*********************************************************************/
+#ifdef ARMV7A
 
 #include "Mb800.h"
@@ -145,2 +146,4 @@
 } // end namespace sensor
 } // end namespace flair
+
+#endif
Index: trunk/lib/FlairSensorActuator/src/NeoM8N.cpp
===================================================================
--- trunk/lib/FlairSensorActuator/src/NeoM8N.cpp	(revision 262)
+++ trunk/lib/FlairSensorActuator/src/NeoM8N.cpp	(revision 268)
@@ -15,4 +15,5 @@
 //
 /*********************************************************************/
+#ifdef ARMV7A
 
 #include "NeoM8N.h"
@@ -143,2 +144,4 @@
 } // end namespace sensor
 } // end namespace flair
+
+#endif
Index: trunk/lib/FlairSensorActuator/src/Novatel.cpp
===================================================================
--- trunk/lib/FlairSensorActuator/src/Novatel.cpp	(revision 262)
+++ trunk/lib/FlairSensorActuator/src/Novatel.cpp	(revision 268)
@@ -15,4 +15,5 @@
 //
 /*********************************************************************/
+#ifdef ARMV7A
 
 #include "Novatel.h"
@@ -98,2 +99,4 @@
 } // end namespace sensor
 } // end namespace flair
+
+#endif
Index: trunk/lib/FlairSensorActuator/src/Ps3Eye.cpp
===================================================================
--- trunk/lib/FlairSensorActuator/src/Ps3Eye.cpp	(revision 262)
+++ trunk/lib/FlairSensorActuator/src/Ps3Eye.cpp	(revision 268)
@@ -15,4 +15,5 @@
 //
 /*********************************************************************/
+#ifdef ARMV7A
 
 #include "Ps3Eye.h"
@@ -35,2 +36,4 @@
 } // end namespace sensor
 } // end namespace flair
+
+#endif
Index: trunk/lib/FlairSensorActuator/src/SimuBldc.cpp
===================================================================
--- trunk/lib/FlairSensorActuator/src/SimuBldc.cpp	(revision 262)
+++ trunk/lib/FlairSensorActuator/src/SimuBldc.cpp	(revision 268)
@@ -15,4 +15,6 @@
 //
 /*********************************************************************/
+#ifdef CORE2_64
+
 #include "SimuBldc.h"
 #include <FrameworkManager.h>
@@ -78,2 +80,4 @@
 } // end namespace sensor
 } // end namespace flair
+
+#endif
Index: trunk/lib/FlairSensorActuator/src/SimuCamera.cpp
===================================================================
--- trunk/lib/FlairSensorActuator/src/SimuCamera.cpp	(revision 262)
+++ trunk/lib/FlairSensorActuator/src/SimuCamera.cpp	(revision 268)
@@ -15,4 +15,5 @@
 //
 /*********************************************************************/
+#ifdef CORE2_64
 
 #include "SimuCamera.h"
@@ -94,2 +95,4 @@
 } // end namespace sensor
 } // end namespace flair
+
+#endif
Index: trunk/lib/FlairSensorActuator/src/SimuGps.cpp
===================================================================
--- trunk/lib/FlairSensorActuator/src/SimuGps.cpp	(revision 262)
+++ trunk/lib/FlairSensorActuator/src/SimuGps.cpp	(revision 268)
@@ -15,4 +15,5 @@
 //
 /*********************************************************************/
+#ifdef CORE2_64
 
 #include "SimuGps.h"
@@ -133,2 +134,4 @@
 } // end namespace sensor
 } // end namespace flair
+
+#endif
Index: trunk/lib/FlairSensorActuator/src/SimuImu.cpp
===================================================================
--- trunk/lib/FlairSensorActuator/src/SimuImu.cpp	(revision 262)
+++ trunk/lib/FlairSensorActuator/src/SimuImu.cpp	(revision 268)
@@ -15,4 +15,5 @@
 //
 /*********************************************************************/
+#ifdef CORE2_64
 
 #include "SimuImu.h"
@@ -93,2 +94,4 @@
 } // end namespace sensor
 } // end namespace flair
+
+#endif
Index: trunk/lib/FlairSensorActuator/src/SimuLaser.cpp
===================================================================
--- trunk/lib/FlairSensorActuator/src/SimuLaser.cpp	(revision 262)
+++ trunk/lib/FlairSensorActuator/src/SimuLaser.cpp	(revision 268)
@@ -15,4 +15,6 @@
 //
 /*********************************************************************/
+#ifdef CORE2_64
+
 #include "SimuLaser.h"
 #include <FrameworkManager.h>
@@ -76,2 +78,4 @@
 } // end namespace sensor
 } // end namespace flair
+
+#endif
Index: trunk/lib/FlairSensorActuator/src/SimuPressureSensor.cpp
===================================================================
--- trunk/lib/FlairSensorActuator/src/SimuPressureSensor.cpp	(revision 262)
+++ trunk/lib/FlairSensorActuator/src/SimuPressureSensor.cpp	(revision 268)
@@ -15,4 +15,6 @@
 //
 /*********************************************************************/
+#ifdef CORE2_64
+
 #include "SimuPressureSensor.h"
 #include <FrameworkManager.h>
@@ -75,2 +77,4 @@
 } // end namespace sensor
 } // end namespace flair
+
+#endif
Index: trunk/lib/FlairSensorActuator/src/SimuUs.cpp
===================================================================
--- trunk/lib/FlairSensorActuator/src/SimuUs.cpp	(revision 262)
+++ trunk/lib/FlairSensorActuator/src/SimuUs.cpp	(revision 268)
@@ -15,4 +15,6 @@
 //
 /*********************************************************************/
+#ifdef CORE2_64
+
 #include "SimuUs.h"
 #include <FrameworkManager.h>
@@ -75,2 +77,4 @@
 } // end namespace sensor
 } // end namespace flair
+
+#endif
Index: trunk/lib/FlairSensorActuator/src/Srf08.cpp
===================================================================
--- trunk/lib/FlairSensorActuator/src/Srf08.cpp	(revision 262)
+++ trunk/lib/FlairSensorActuator/src/Srf08.cpp	(revision 268)
@@ -15,4 +15,5 @@
 //
 /*********************************************************************/
+#ifdef ARMV7A
 
 #include "Srf08.h"
@@ -221,2 +222,4 @@
 } // end namespace sensor
 } // end namespace flair
+
+#endif
Index: trunk/lib/FlairSensorActuator/src/XBldc.cpp
===================================================================
--- trunk/lib/FlairSensorActuator/src/XBldc.cpp	(revision 262)
+++ trunk/lib/FlairSensorActuator/src/XBldc.cpp	(revision 268)
@@ -15,4 +15,5 @@
 //
 /*********************************************************************/
+#ifdef ARMV7A
 
 #include "XBldc.h"
@@ -40,2 +41,4 @@
 } // end namespace actuator
 } // end namespace flair
+
+#endif
Index: trunk/lib/FlairSensorActuator/src/XBldc_impl.cpp
===================================================================
--- trunk/lib/FlairSensorActuator/src/XBldc_impl.cpp	(revision 262)
+++ trunk/lib/FlairSensorActuator/src/XBldc_impl.cpp	(revision 268)
@@ -15,4 +15,5 @@
 //
 /*********************************************************************/
+#ifdef ARMV7A
 
 #include "XBldc_impl.h"
@@ -150,2 +151,4 @@
   return sat_value;
 }
+
+#endif
Index: trunk/lib/FlairVisionFilter/CMakeLists.txt
===================================================================
--- trunk/lib/FlairVisionFilter/CMakeLists.txt	(revision 262)
+++ trunk/lib/FlairVisionFilter/CMakeLists.txt	(revision 268)
@@ -2,4 +2,6 @@
 cmake_minimum_required(VERSION 2.8)
 include($ENV{FLAIR_ROOT}/flair-dev/cmake-modules/GlobalCmakeFlair.cmake)
+
+if(NOT "${CMAKE_SYSTEM_PROCESSOR_DEFAULTTUNE}" MATCHES "armv5te")
 
 find_package(LibXml2 REQUIRED)
@@ -49,2 +51,10 @@
 
 add_dependencies(${PROJECT_NAME} compile_info)
+
+else()
+    if(DEFINED CMAKE_SYSTEM_PROCESSOR_DEFAULTTUNE)
+        warn("${PROJECT_NAME} will not be built for ${CMAKE_SYSTEM_PROCESSOR_DEFAULTTUNE} architecture")
+    else()
+        warn("${PROJECT_NAME} will not be built for ${CMAKE_SYSTEM_PROCESSOR} architecture")
+    endif()
+endif()